# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union
from . import _utilities, _tables
from . import outputs
from ._inputs import *

__all__ = ['PacketFilterRule']


class PacketFilterRule(pulumi.CustomResource):
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 expressions: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['PacketFilterRuleExpressionArgs']]]]] = None,
                 packet_filter_id: Optional[pulumi.Input[str]] = None,
                 zone: Optional[pulumi.Input[str]] = None,
                 __props__=None,
                 __name__=None,
                 __opts__=None):
        """
        Manages a SakuraCloud Packet Filter Rules.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_sakuracloud as sakuracloud

        foobar = sakuracloud.PacketFilter("foobar", description="description")
        rules = sakuracloud.PacketFilterRule("rules",
            packet_filter_id=foobar.id,
            expressions=[
                sakuracloud.PacketFilterRuleExpressionArgs(
                    protocol="tcp",
                    destination_port="22",
                ),
                sakuracloud.PacketFilterRuleExpressionArgs(
                    protocol="tcp",
                    destination_port="80",
                ),
                sakuracloud.PacketFilterRuleExpressionArgs(
                    protocol="tcp",
                    destination_port="443",
                ),
                sakuracloud.PacketFilterRuleExpressionArgs(
                    protocol="icmp",
                ),
                sakuracloud.PacketFilterRuleExpressionArgs(
                    protocol="fragment",
                ),
                sakuracloud.PacketFilterRuleExpressionArgs(
                    protocol="udp",
                    source_port="123",
                ),
                sakuracloud.PacketFilterRuleExpressionArgs(
                    protocol="tcp",
                    destination_port="32768-61000",
                ),
                sakuracloud.PacketFilterRuleExpressionArgs(
                    protocol="udp",
                    destination_port="32768-61000",
                ),
                sakuracloud.PacketFilterRuleExpressionArgs(
                    protocol="ip",
                    allow=False,
                    description="Deny ALL",
                ),
            ])
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['PacketFilterRuleExpressionArgs']]]] expressions: One or more `expression` blocks as defined below. Changing this forces a new resource to be created.
        :param pulumi.Input[str] packet_filter_id: The id of the packet filter that set expressions to. Changing this forces a new resource to be created.
        :param pulumi.Input[str] zone: The name of zone that the PacketFilter Rule will be created. (e.g. `is1a`, `tk1a`). Changing this forces a new resource to be created.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            __props__['expressions'] = expressions
            if packet_filter_id is None and not opts.urn:
                raise TypeError("Missing required property 'packet_filter_id'")
            __props__['packet_filter_id'] = packet_filter_id
            __props__['zone'] = zone
        super(PacketFilterRule, __self__).__init__(
            'sakuracloud:index/packetFilterRule:PacketFilterRule',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            expressions: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['PacketFilterRuleExpressionArgs']]]]] = None,
            packet_filter_id: Optional[pulumi.Input[str]] = None,
            zone: Optional[pulumi.Input[str]] = None) -> 'PacketFilterRule':
        """
        Get an existing PacketFilterRule resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['PacketFilterRuleExpressionArgs']]]] expressions: One or more `expression` blocks as defined below. Changing this forces a new resource to be created.
        :param pulumi.Input[str] packet_filter_id: The id of the packet filter that set expressions to. Changing this forces a new resource to be created.
        :param pulumi.Input[str] zone: The name of zone that the PacketFilter Rule will be created. (e.g. `is1a`, `tk1a`). Changing this forces a new resource to be created.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["expressions"] = expressions
        __props__["packet_filter_id"] = packet_filter_id
        __props__["zone"] = zone
        return PacketFilterRule(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def expressions(self) -> pulumi.Output[Optional[Sequence['outputs.PacketFilterRuleExpression']]]:
        """
        One or more `expression` blocks as defined below. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "expressions")

    @property
    @pulumi.getter(name="packetFilterId")
    def packet_filter_id(self) -> pulumi.Output[str]:
        """
        The id of the packet filter that set expressions to. Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "packet_filter_id")

    @property
    @pulumi.getter
    def zone(self) -> pulumi.Output[str]:
        """
        The name of zone that the PacketFilter Rule will be created. (e.g. `is1a`, `tk1a`). Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "zone")

    def translate_output_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return _tables.SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

