# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union
from . import _utilities, _tables

__all__ = ['PrivateHost']


class PrivateHost(pulumi.CustomResource):
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 class_: Optional[pulumi.Input[str]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 icon_id: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 tags: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 zone: Optional[pulumi.Input[str]] = None,
                 __props__=None,
                 __name__=None,
                 __opts__=None):
        """
        Manages a SakuraCloud Private Host.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_sakuracloud as sakuracloud

        foobar = sakuracloud.PrivateHost("foobar",
            description="description",
            tags=[
                "tag1",
                "tag2",
            ])
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] class_: The class of the PrivateHost. This will be one of [`dynamic`/`ms_windows`]. Default:`dynamic`.
        :param pulumi.Input[str] description: The description of the PrivateHost. The length of this value must be in the range [`1`-`512`].
        :param pulumi.Input[str] icon_id: The icon id to attach to the PrivateHost.
        :param pulumi.Input[str] name: The name of the PrivateHost. The length of this value must be in the range [`1`-`64`].
        :param pulumi.Input[Sequence[pulumi.Input[str]]] tags: Any tags to assign to the PrivateHost.
        :param pulumi.Input[str] zone: The name of zone that the PrivateHost will be created. (e.g. `is1a`, `tk1a`). Changing this forces a new resource to be created.
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            __props__['class_'] = class_
            __props__['description'] = description
            __props__['icon_id'] = icon_id
            __props__['name'] = name
            __props__['tags'] = tags
            __props__['zone'] = zone
            __props__['assigned_core'] = None
            __props__['assigned_memory'] = None
            __props__['hostname'] = None
        super(PrivateHost, __self__).__init__(
            'sakuracloud:index/privateHost:PrivateHost',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            assigned_core: Optional[pulumi.Input[int]] = None,
            assigned_memory: Optional[pulumi.Input[int]] = None,
            class_: Optional[pulumi.Input[str]] = None,
            description: Optional[pulumi.Input[str]] = None,
            hostname: Optional[pulumi.Input[str]] = None,
            icon_id: Optional[pulumi.Input[str]] = None,
            name: Optional[pulumi.Input[str]] = None,
            tags: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            zone: Optional[pulumi.Input[str]] = None) -> 'PrivateHost':
        """
        Get an existing PrivateHost resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] assigned_core: The total number of CPUs assigned to servers on the private host.
        :param pulumi.Input[int] assigned_memory: The total size of memory assigned to servers on the private host.
        :param pulumi.Input[str] class_: The class of the PrivateHost. This will be one of [`dynamic`/`ms_windows`]. Default:`dynamic`.
        :param pulumi.Input[str] description: The description of the PrivateHost. The length of this value must be in the range [`1`-`512`].
        :param pulumi.Input[str] hostname: The hostname of the private host.
        :param pulumi.Input[str] icon_id: The icon id to attach to the PrivateHost.
        :param pulumi.Input[str] name: The name of the PrivateHost. The length of this value must be in the range [`1`-`64`].
        :param pulumi.Input[Sequence[pulumi.Input[str]]] tags: Any tags to assign to the PrivateHost.
        :param pulumi.Input[str] zone: The name of zone that the PrivateHost will be created. (e.g. `is1a`, `tk1a`). Changing this forces a new resource to be created.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["assigned_core"] = assigned_core
        __props__["assigned_memory"] = assigned_memory
        __props__["class_"] = class_
        __props__["description"] = description
        __props__["hostname"] = hostname
        __props__["icon_id"] = icon_id
        __props__["name"] = name
        __props__["tags"] = tags
        __props__["zone"] = zone
        return PrivateHost(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="assignedCore")
    def assigned_core(self) -> pulumi.Output[int]:
        """
        The total number of CPUs assigned to servers on the private host.
        """
        return pulumi.get(self, "assigned_core")

    @property
    @pulumi.getter(name="assignedMemory")
    def assigned_memory(self) -> pulumi.Output[int]:
        """
        The total size of memory assigned to servers on the private host.
        """
        return pulumi.get(self, "assigned_memory")

    @property
    @pulumi.getter(name="class")
    def class_(self) -> pulumi.Output[Optional[str]]:
        """
        The class of the PrivateHost. This will be one of [`dynamic`/`ms_windows`]. Default:`dynamic`.
        """
        return pulumi.get(self, "class_")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        The description of the PrivateHost. The length of this value must be in the range [`1`-`512`].
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter
    def hostname(self) -> pulumi.Output[str]:
        """
        The hostname of the private host.
        """
        return pulumi.get(self, "hostname")

    @property
    @pulumi.getter(name="iconId")
    def icon_id(self) -> pulumi.Output[Optional[str]]:
        """
        The icon id to attach to the PrivateHost.
        """
        return pulumi.get(self, "icon_id")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The name of the PrivateHost. The length of this value must be in the range [`1`-`64`].
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def tags(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        Any tags to assign to the PrivateHost.
        """
        return pulumi.get(self, "tags")

    @property
    @pulumi.getter
    def zone(self) -> pulumi.Output[str]:
        """
        The name of zone that the PrivateHost will be created. (e.g. `is1a`, `tk1a`). Changing this forces a new resource to be created.
        """
        return pulumi.get(self, "zone")

    def translate_output_property(self, prop):
        return _tables.CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return _tables.SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

